#include<stdio.h>
#include<stdlib.h>
#include<math.h>
#include"dSFMT.h"

#define Maxtime	pow(10,6)		//time
#define c		0.1				//parameter c
#define p		1				//parameter p
#define	q		1				//parameter q
double a[p] = {0.5};
double b[q] = {0.3};

dsfmt_t dsfmt1;


double rand_gauss( double mu , double sigma ){	//rand : gauss
	double x1 = dsfmt_genrand_close_open(&dsfmt1);
	double x2 = dsfmt_genrand_close_open(&dsfmt1);
	double y  = sigma * ( sqrt(-2 * log(x1) ) * cos( 2*M_PI * x2)) + mu;
	return y;
}

int double_comp(const void *_a, const void *_b) {	//for qsort
	double a = *(double *)_a;
	double b = *(double *)_b;
	
	if (a > b)		return -1;
	else if (a < b)	return 1;
	else			return 0;
}


int main(void){
	dsfmt_init_gen_rand(&dsfmt1,1);
	
	int t,i;
	double *x , *sigma;
	x = (double *)calloc( Maxtime, sizeof(double));
	sigma = (double *)calloc( Maxtime, sizeof(double));
	
	FILE *fp , *fp2;
	if( (fp=fopen("time3_4_7.dat","w")) ==NULL){
		printf("FILE Error : time\n");
		exit(1);
	}
	if( (fp2=fopen("CDF3_4_7.dat","w")) ==NULL){
		printf("FILE Error :CDF\n");
		exit(1);
	}
	
	int mintime = (p > q)? q:p;
	
	for( t=0 ; t< Maxtime ; t++){	//trial
		if( t >= mintime){
			for(i=1;i<=p;i++){
				sigma[t] += a[i-1]*pow(x[t-i],2);
			}
			for(i=1;i<=q;i++){
				sigma[t] += b[i-1]*sigma[t-i];
			}
			sigma[t] += c;
			x[t] = sqrt(sigma[t])*rand_gauss(0.0,1.0);
		}
		
		fprintf(fp , "%d	%f	%f\n",t,x[t],sigma[t]);
	}
	//CDF
	for(i = 0; i < Maxtime ; i++){
		x[i] = fabs(x[i]);
	}
	qsort( x , Maxtime , sizeof(double) , double_comp);
	for(i = 0; i < Maxtime ; i++){
		fprintf( fp2 , "%f %f\n" , x[i] , (double)(i+1)/Maxtime );
	}

	
	fclose(fp);
	fclose(fp2);
	free(x);
	free(sigma);
	return 0;
}



